security:
    # https://symfony.com/doc/current/security.html#registering-the-user-hashing-passwords
    password_hashers:
        Symfony\Component\Security\Core\User\PasswordAuthenticatedUserInterface: 'auto'
    # https://symfony.com/doc/current/security.html#loading-the-user-the-user-provider
    # providers:
    #     # used to reload user from session & other features (e.g. switch_user)
    #     app_user_provider:
    #         entity:
    #             class: App\Entity\User
    #             property: email
    # firewalls:
    #     dev:
    #         pattern: ^/(_(profiler|wdt)|css|images|js)/
    #         security: false
    #     main:
    #         lazy: true
    #         provider: app_user_provider

    #         # activate different ways to authenticate
    #         # https://symfony.com/doc/current/security.html#the-firewall

    #         # https://symfony.com/doc/current/security/impersonating_user.html
    #         # switch_user: true

    # # Easy way to control access for large sections of your site
    # # Note: Only the *first* access control that matches will be used
    # access_control:
    #     # - { path: ^/admin, roles: ROLE_ADMIN }
    #     # - { path: ^/profile, roles: ROLE_USER }
    # https://symfony.com/doc/current/security/authenticator_manager.html
    enable_authenticator_manager: true
    # https://symfony.com/doc/current/security.html#where-do-users-come-from-user-providers
    providers:
        # used to reload user from session & other features (e.g. switch_user)
        app_user_provider:
            entity:
                class: App\Entity\User
                property: email

    firewalls:
        dev:
            pattern: ^/_(profiler|wdt)
            security: false
        main:
            stateless: true
            provider: app_user_provider
            entry_point: jwt
            json_login:
                check_path: /authentication_token
                username_path: email
                password_path: password
                success_handler: lexik_jwt_authentication.handler.authentication_success
                failure_handler: lexik_jwt_authentication.handler.authentication_failure
            jwt: ~

    access_control:
        - { path: ^/docs, roles: PUBLIC_ACCESS } # Allows accessing the Swagger UI
        - { path: ^/authentication_token, roles: PUBLIC_ACCESS }
        - { path: ^/api/users, roles: PUBLIC_ACCESS }
        - { path: ^/api/events, roles: PUBLIC_ACCESS }
        - { path: ^/api/streamers, roles: PUBLIC_ACCESS }
        - { path: ^/api/posts, roles: PUBLIC_ACCESS }
        - { path: ^/api/authentication_token, roles: PUBLIC_ACCESS }

when@test:
    security:
        password_hashers:
            # By default, password hashers are resource intensive and take time. This is
            # important to generate secure password hashes. In tests however, secure hashes
            # are not important, waste resources and increase test times. The following
            # reduces the work factor to the lowest possible values.
            Symfony\Component\Security\Core\User\PasswordAuthenticatedUserInterface:
                algorithm: auto
                cost: 4 # Lowest possible value for bcrypt
                time_cost: 3 # Lowest possible value for argon
                memory_cost: 10 # Lowest possible value for argon
